/**
 * (c) Ilya V. Azarov, 2011. Advanced image upload module for images/multimedia/etc.
 * javascript for normal plupload initialization
 */
function var_dump(arr,level) {
  var dumped_text = "";
  if(!level) level = 0;
  //The padding given at the beginning of the line.
  var level_padding = "";
  for(var j=0; j<level+1; j++) level_padding += "    ";
  if(typeof(arr) == 'object') { //Array/Hashes/Objects
    for(var item in arr) {
      var value = arr[item];
      if(typeof(value) == 'object') { //If it is an array,
        dumped_text += level_padding + "'" + item + "' ...\n";
        dumped_text += var_dump(value,level+1);
      } else {
        dumped_text += level_padding + "'" + item + "' => \"" + value + "\"\n";
      }
    }
  } else { //Stings/Chars/Numbers etc.
    dumped_text = "===>"+arr+"<===("+typeof(arr)+")";
  }
  return dumped_text;
}
Drupal = Drupal || {};
Drupal.advupload = Drupal.advupload || {};
Drupal.advupload.tempfiles = Drupal.advupload.tempfiles || null;
// here we will store node id of uploaded files/nodes
Drupal.advupload.loaded_files_nids=new Array();
Drupal.advupload.loaded_files_nodestructures = new Array();
Drupal.advupload.makePluploaderStop = function(up, errormessage, file){
  $('#advupload-uploader').hide();
  $('#advupload-uploader-wrapper').prepend('<div id="advupload-uploader-stop-error"></div>');
  $('#advupload-uploader-stop-error').text(errormessage);
  up.removeFile(file); // here will be JS crash
  up.stop();
}
// that must run before death - to show uploaded blocks, etc.
// if was_error true - do nothing;
Drupal.advupload.runJsonNode = function(data){
  d = eval('(' + data + ')');
  if(typeof(d.result) != 'undefined')Drupal.advupload.loaded_files_nodestructures[Drupal.advupload.loaded_files_nodestructures.length] = d.result;
}
Drupal.advupload.ajaxLoadNodeDashBoard = function(nid, newtokenvalue){
  var url1 = Drupal.settings.advupload.plupload.node_json_url 
          + "?nid=" + nid
          + "&token=" + Drupal.settings.advupload.plupload.drupal_token_name
          + "&token_value=" + newtokenvalue;
  $.ajax({
    url: url1,
    success: Drupal.advupload.runJsonNode,
    async:false
  });
}
Drupal.advupload.runOnComplete = function(up, was_error){
  if(Drupal.advupload.loaded_files_nodestructures.length){
    $('#advupload-uploader').hide(20);
    $('#advupload-messages').html(
      '<span class="advupload-success">' 
      + Drupal.t('Files were successfully uploaded') 
      + '</span>'
    );
    $('#advupload-uploader-additional-own').append('<h3>' + Drupal.t('Nodes were created:') + '</h3>');
  }
  for(var i in Drupal.advupload.loaded_files_nodestructures){
    $('#advupload-uploader-additional-own').append(Drupal.advupload.loaded_files_nodestructures[i].html);
  }
  alert(Drupal.t('Upload complete'));
}
$(document).ready(function(){
  plupload.addI18n({
    'Select files' : Drupal.t('Select files'),
    'Add files to the upload queue and click the start button.' : Drupal.t('Add files to the upload queue and click the start button.'),
    'Filename' : Drupal.t('Filename'),
    'Status' : Drupal.t('Status'),
    'Size' : Drupal.t('Size'),
    'Add files' : Drupal.t('Add files'),
    'Stop current upload' : Drupal.t('Stop current upload'),
    'Start uploading queue' : Drupal.t('Start uploading queue'),
    'Drag files here.' : Drupal.t('Drag files here.'),
    'Node title' : Drupal.t('Node title'),
    'Error: File too large: ' :  Drupal.t('Error: File too large: '),
    "Error: Invalid file extension: " : Drupal.t("Error: Invalid file extension: "),
    'Unsupported usage of module' : Drupal.t('Unsupported usage of module')
  });

  if(Drupal.settings.advupload.plupload.uploadtype == 'multinode'){
    $('#advupload-uploader').advupload_pluploadQueue({ 
      // main settings we can preconfigure - see http://plupload.com/documentation.php
      runtimes : Drupal.settings.advupload.plupload.runtimes,
      url : Drupal.settings.advupload.plupload.url,
      max_file_size : Drupal.settings.advupload.plupload.max_filesize_per_file 
        // that's if fucking awful - we will limit that to 2GB
        //(cause PHP+drupal API anyway do not work with larger sizes on i386
        ? Drupal.settings.advupload.plupload.max_filesize_per_file : 2147483648,
      chunk_size : Drupal.settings.advupload.plupload.chunk_size,
      filters : Drupal.settings.advupload.plupload.filters,
      flash_swf_url : Drupal.settings.advupload.plupload.flash_swf_url,
      silverlight_xap_url : Drupal.settings.advupload.plupload.silverlight_xap_url,
      // other settings - interface lulz
      multipart : true,
      multipart_params : {
        token_name : Drupal.settings.advupload.plupload.drupal_token_name,
        token_value : Drupal.settings.advupload.plupload.drupal_token_value
      },
      drupal_max_total_upload_size: Drupal.settings.advupload.drupal_max_total_upload_size
    });
    if(Drupal.settings.advupload.plupload.max_filesize_per_file != 0){
    }
    $('#advupload-uploader').advupload_pluploadQueue().bind('QueueChanged', function(up){
      if(Drupal.settings.advupload.drupal_max_total_upload_size){
        var size_sum = 0;
        for(var i in up.files) if(!up.files[i].loaded) size_sum += up.files[i].size;
        if(size_sum > Drupal.settings.advupload.drupal_max_total_upload_size){
          alert(Drupal.t('Can not add files. Total size of files is more than maximum  total upload size') );
          up.removeFile(up.files[i] );  
        }
      }
    });
    //before upload
    $('#advupload-uploader').advupload_pluploadQueue().bind('UploadFile', function(up, file) {
      var str = $('#' + file.id + ' input.node-title').val();
      $.extend(
        $('#advupload-uploader').advupload_pluploadQueue().settings.multipart_params,
        {drupal_node_title :  str, file_size : file.size }
      );
    });
    $('#advupload-uploader').advupload_pluploadQueue().bind('FileUploaded', function(up, file, r) {
      // here we must extract different node info from resp and  give links to user later. e.g. via ajax subrequest
      var response;
      if( (typeof(r) == 'object') && (typeof(r.response) == 'string') ) response = eval('(' + r.response + ')');

      if( typeof(response.error) == 'object' ) if ( response.error.code >= 800){
        // errors not critical for whole form
        file.status = plupload.FAILED;
        alert(Drupal.t('Error uploading file ') + file.name + '. ' + Drupal.t('Server response: ') + response.error.message);
      }
      if( (typeof(response.result) != 'undefined') && (response.result == 'success') ){
        Drupal.advupload.loaded_files_nids[Drupal.advupload.loaded_files_nids.length] = response.data.nid;
        Drupal.advupload.ajaxLoadNodeDashBoard(response.data.nid, response.data.newtokenvalue);
      }
      if( (typeof(response) == 'undefined') ) Drupal.advupload.makePluploaderStop(
        up,
        Drupal.t(
          'There was wrong response from the server. That\'s why some files cannot be uploaded. Refresh page and try again or contact site administrator'
        ),
        file
      );
      if(up.total.uploaded == up.files.length){
        // add cleanup. links to added nodes, etc
        Drupal.advupload.runOnComplete();
      }
    });
    // make uploader stop on errors
    $('#advupload-uploader').advupload_pluploadQueue().bind('ChunkUploaded', function(up, file, r){
      var response = undefined;
      if( (typeof(r) == 'object') && (typeof(r.response) == 'string') ) response = eval('(' + r.response + ')');
      if( (typeof(response) != 'undefined') ){
        var code = 0;
        if(typeof(response.error) == 'object'){
          code = response.error.code;
          if(code < 800){ // blocking errors, e.g/ system errors/hacks
            response.error.file = file;
            // !!! later make more pleasant messages
            var errmessage = Drupal.t(
              'There was wrong response from the server. That\'s why some files cannot be uploaded. Refresh page and try again or contact site administrator.'
            );
            if(typeof(response.error.message) != 'undefined') 
              errmessage = errmessage + Drupal.t(' Additional information from server: ') + response.error.message + ' ';
            errmessage = errmessage + Drupal.t('Error occured while uploading following file: ') + file.name;
            Drupal.advupload.makePluploaderStop(up, errmessage, file);
          }
        }else{
          // NORMAL PROCESSING - NOTHING HERE - GO TO QUEUE CHANGE
        }
        delete response;
      }else Drupal.advupload.makePluploaderStop(
        up,
        Drupal.t(
          'There was wrong response from the server. That\'s why some files cannot be uploaded. Refresh page and try again or contact site administrator'
        ),
        file
      );
    });
  }
});
