<?php
/**
 * (c) Ilya V. Azarov, 2011. Advanced image upload module for images/multimedia/etc.
 * json menu handlers to make correct answers for plupload requests
 */
function _advupload_error_message($code){
  $error_messages = array(
    600 => t('Unsupported usage of upload module'),
    601 => t('Wrong tokens. Form you use is incorrect. Try reload page'),
    603 => t('You\'re using upload JSON script incorrectly. Try reload page'),
    604 => t('Thats impossible - 0 chunks in one upload. Tell to site administration'),
    605 => t('Filename is not valid'),
    // no in $_FILES or no is_uploaded_file() 
    606 => t('Something wrong with file upload on the server. Tell to the server administrator'),
    607 => t('Can not create or open temporary file for writing'),
    608 => t('Error during temporary file saving while reading input file'),
    609 => t('Error during temporary file saving while writing input file'),
    610 => t('Wrong chunk number'),
    611 => t('Database error occured'),
    612 => t('Too large file for upload. Sorry.'),
    613 => t('Internal module API error. If you\'re site administrator please tell to developer about that'),
    614 => t('File you\'re going to upload is to large'),
    615 => t('Chunk number is not null but no temporary file for it'),
    616 => t('Uploaded chuncks have more filesize then was declared'),
    617 => t('Uploaded file size differs from declared'),
    666 => t('Unknown error'),
    618 => t('Internal system misconfiguration error. Contact administrator'),
    619 => t('Cannot create directory for new uploaded file'),
    620 => t('Error while saving uploaded file'),
    800 => t('You\'re trying upload file with wrong extension'),
  );
  return isset($error_messages[$code] ) ? $error_messages[$code] : $error_messages[666];
}
function _advupload_error_die($code = 666, $additional = array() ){
  error_log('Error code: ' . $code);
  die(
    drupal_to_js(
      array(
        'jsonrpc' => '2.0', 
        'error' => array('code' => $code, 'message' =>  _advupload_error_message($code) ),
        'error_data' => $additional,
        'id' => 'id'
      )
    ) 
  );
}

/**
 * our custom impleentation of field_file_save_file
 * but we not copy file - we make move of them
 * 
 **/
function _advupload_field_file_save_file($filepath, $dest, $fname, $validators = array() ) {
  global $user;
  module_load_include('inc', 'filefield', 'field_file');
  $account = $user;
  $validators = array();
  // Add in our check of the the file name length.
  $validators['file_validate_name_length'] = array();

  // Begin building file object.
  $file = new stdClass();
  $file->uid = $account->uid;
  $file->filename = $fname;
  $file->filepath = $filepath;
  $file->filemime = module_exists('mimedetect') ? mimedetect_mime($file) : file_get_mimetype($file->filename);

  // Rename potentially executable files, to help prevent exploits.
  if (preg_match('/\.(php|pl|py|cgi|asp|js)$/i', $file->filename) && (substr($file->filename, -4) != '.txt')) {
    $file->filemime = 'text/plain';
    $file->filepath .= '.txt';
    $file->filename .= '.txt';
  }


  $file->source = 'field_file_save_file';
  $file->destination = file_destination(file_create_path($dest .'/'. $file->filename), FILE_EXISTS_RENAME);
  // for future moar filesize
  $file->filesize = filesize($filepath);

  // Call the validation functions.
  $errors = array();
  foreach ($validators as $function => $args) {
      // Add the $file variable to the list of arguments and pass it by
      // reference (required for PHP 5.3 and higher).
    array_unshift($args, NULL);
    $args[0] = &$file;
    $errors = array_merge($errors, call_user_func_array($function, $args));
  }

  // !!!! do we need that bullshit? :-)
  if(false) if (!empty($errors)) {
    $message = t('The selected file %name could not be saved.', array('%name' => $file->filename));
    if (count($errors) > 1) {
      $message .= '<ul><li>'. implode('</li><li>', $errors) .'</li></ul>';
    }
    else {
      $message .= ' '. array_pop($errors);
    }
    form_set_error($file->source, $message);
    return 0;
  }

  if (!file_move($file, $file->destination, FILE_EXISTS_RENAME)) {
    //form_set_error($file->source, t('File upload error. Could not move uploaded file.'));
    //watchdog('file', 'Upload error. Could not move file %file to destination %destination.', array('%file' => $file->filename, '%destination' => $file->destination));
    return 0;
  }

  // If we made it this far it's safe to record this file in the database.
  $file->status = FILE_STATUS_TEMPORARY;
  $file->timestamp = time();
  // Insert new record to the database.
  drupal_write_record('files', $file);

  // Let modules add additional properties to the yet barebone file object.
  foreach (module_implements('file_insert') as $module) {
    $function =  $module .'_file_insert';
    $function($file);
  }
  _field_file_cache($file); // cache the file in order to minimize load queries
  return (array)$file;
}
function _advupload_create_node($type, $field, $form_state_values, $file, $addfields = array() ){
  global $user;
  module_load_include('inc', 'node', 'node.pages');
  $node = new stdClass();
  $node->type = $type;
  $node->uid = $user->uid;
  $node->name = $user->name;
  $node->title = $form_state_values['title'];
  $node->body = $form_state_values['body'];
  node_object_prepare($node);
  // add filefield to the node 
  $field_name = $field['field_name'];
  $node->$field_name = array($file);
  // additional fields - or just make hook later ????
  if(count($addfields) ) foreach($addfields as $key => $val) $node->$key = $val;
  // do we need that? the above hook may make all
  // Add any additional cck fields set during import.
  $tf = content_types($type);
  if (!empty($tf['fields'])) {
    foreach ($tf['fields'] as $name => $field) {
      if ($field['type'] != 'filefield') {
        $node->$name = $form_state_values[$name];
      }
    }
  }
  $node->form_id = $node->type .'_node_form';
  $node = node_submit($node);
  // now here ready node structure. but may be we will need integration hooks like saving in OG or saving into gallery/chapter/ect
  module_invoke_all('advupload_before_node_save', $node);
  node_save($node);
  module_invoke_all('advupload_after_node_save', $node);
  return $node;
}
// for now it just works for $uptype = multinode
// later we will make more function calls just from one place depending on $uptype
function advupload_json_upload($type, $uptype){
/*  
 * $_POST structure is
 * 'chunk'  chunk number
 * 'chunks'  chunck count
 * 'name' initial filename
 * 'drupal_node_title' node title for the new node
 * 'token_name' - form token for checks
 * 'token_value' - checksum to check form is correct
 * file_size - size of file we're going to upload
 */
  global $user;
  module_load_include('inc', 'advupload', 'advupload.api');
  // log all we do receive
  error_log('json_upload(): called');
  error_log('json_upload(): dump $_POST');
  foreach(explode("\n", var_export($_POST, TRUE) ) as $val) error_log('advupload_json_upload() dump: ' . $val);
  // setting JSON headers to make all correct
  drupal_set_header('Content-type: text/javascript; charset=utf-8');
  drupal_set_header('Expires: Mon, 26 Jul 1997 05:00:00 GMT');
  drupal_set_header('Last-Modified: ' . gmdate('D, d M Y H:i:s') . ' GMT');
  drupal_set_header('Cache-Control: no-store, no-cache, must-revalidate');
  drupal_set_header('Pragma: no-cache');
  if(isset($_POST['token_name'] ) && isset($_POST['token_value'] ) ){
    if(drupal_valid_token($_POST['token_value'], $_POST['token_name']) ){
      //  year - this thing's correct and made from uniqid - we need more unique file names
      // it will allow us make some percistence and more security cause it's checked and 
      // not's  so easy substitute that :)
      $old_uniqid = str_replace('advupload_plupload_' . $type . '_' . $uptype . '_', '', $_POST['token_name'] );
      $messages = array();
      $tmpdir = _advupload_get_tmp();
      $chunk = @intval($_POST['chunk'] );
      $chunks =  @intval($_POST['chunks'] );
      if($chunk >= $chunks) _advupload_error_die(610, $_POST); // form the too smart assholes :-) 
      if($chunks == 0) _advupload_error_die(604);
      // FOR LARGER SIZES USE CURL + COMPARE VIA STRINGS
      $file_size = @intval($_POST['file_size'] );
      $fieldname = variable_get('advupload_type_' . $type . '_fieldname', '');
      if(empty($fieldname) ) _advupload_error_die(618, $_POST);
      $fieldsettings = _advupload_get_filefield_settings($type, $fieldname);
      if(!is_numeric($fieldsettings['max_filesize_per_file'] ) ) _advupload_error_die(613);
      $max_filesize_per_file = @intval($fieldsettings['max_filesize_per_file'] );
      $allowed_extensions = $fieldsettings['file_extensions'];
      if($fieldsettings['max_filesize_per_file'] > 0) 
        if($file_size > $fieldsettings['max_filesize_per_file'] )  _advupload_error_die(614, $_POST);
      $fname = empty($_POST['name'] ) ? '' : $_POST['name'];
      // try validate extensions
      $file = new stdClass();
      $file->filename =  $fname;
      $errors = file_validate_extensions($file, $allowed_extensions);
      unset($file);
      error_log(var_export($errors, TRUE) );
      error_log($allowed_extensions);
      error_log($fname);
      if(count($errors) ) _advupload_error_die(800, $_POST); 
      error_log(var_export($errors, true) );
      unset($errors);
      $fname = file_munge_filename(preg_replace('/[^\w\._]+/u', '', $fname), $allowed_extensions, FALSE); // this chickens don't know what does unicode means %)
      if(empty($fname) ) _advupload_error_die(605, $_POST);
      if(isset($_FILES['file'] ['tmp_name'] ) ){
        // that will be about unique
        $tmpfname = file_munge_filename($old_uniqid . '-' . $fname, $allowed_extensions, FALSE);
        // !!!! modify if more load and more files in one dir, dir 0/1/2/3/4/5  struct by checksums if needed
        $tmpfpath = $tmpdir . '/' . $tmpfname;
        if($max_filesize_per_file > 0)if(filesize($_FILES['file']['tmp_name'] ) > $max_filesize_per_file )  _advupload_error_die(614, $_POST);
        $fid = 0; // id in database
        if($chunk > 0){
          $result = db_query(
            'SELECT fid FROM {files} WHERE uid=%d AND status=%d AND filepath=\'%s\'', 
            $user->uid, FILE_STATUS_TEMPORARY, $tmpfpath
          );
          if($o = db_fetch_object($result) ) $fid = $o->fid;
          if($fid == 0) _advupload_error_die(615, $_POST);
        }
        $out = fopen($tmpfpath, $chunk == 0 ? "wb" : "ab");
        if($out){
          $in = fopen($_FILES['file']['tmp_name'], "rb");
          if($in){
            $noerror = TRUE;
            while($noerror && ($buff = fread($in, 4096) ) ){
              $noerror = (fwrite($out, $buff) !== FALSE);
            }
            fclose($in);
            fclose($out);
            if($noerror){
              $nowsize = filesize($tmpfpath);
              if($nowsize > $file_size){ // cleanup, death
                @unlink($tmpfpath);
                if($fid) db_query('DELETE FROM {files} WHERE fid=%d', $fid);
                _advupload_error_die(616, $_POST);
              }
              if($fid) db_query('UPDATE {files} SET filesize=%d, timestamp=%d WHERE fid=%d', $fid, time() );
              else{
                if(
                  db_query(
                    'INSERT INTO {files}(uid,filename,filepath,filesize,status,timestamp) VALUES(%d, \'%s\', \'%s\', %d, %d, %d)',
                     $user->uid, $fname, $tmpfpath, $nowsize, FILE_STATUS_TEMPORARY, time()
                  ) 
                ){}else advupload_error_die(611, $_POST);
                $fid = db_last_insert_id('files', 'fid');
                if(!$fid) advupload_error_die(611, $_POST);
              }
              // now we have about most all to save file
              if ($chunks > 1 && $chunk < $chunks - 1) die(drupal_to_js(array('jsonrpc' => '2.0', 'result' => NULL, 'id' => 'id') ) );
              // all other variants - our :-)
              if($nowsize != $file_size){
                @unlink($tmpfpath);
                db_query('DELETE FROM {files} WHERE fid=%d', $fid);
                _advupload_error_die(617, $_POST);
              }
              // here
              /**
              * step 5. prepare node structure + add some hooks on them
              * step 6. save node on last chunk
              * step 7. save additiona node parameters which is not possible save on node submit
              * step 8. return json with data in node id, etc - think - inside
              * step 9. after all add drupal logging messages inside - file added/node created/etc
              */
              // $tmpfpath - path fo file. $fname - original filename, $fid - id in files table
              // $fieldname name of the field
              // $type - type of node to create
              $node_title = empty($_POST['drupal_node_title'] ) ? $fname : $_POST['drupal_node_title'] ;
              $field = content_fields($fieldname, $type);
              module_load_include('inc', 'filefield', 'filefield_widget');
              $directory = filefield_widget_file_path($field);
              module_load_include('inc', 'filefield', 'field_file');
              if(!field_file_check_directory($directory, FILE_CREATE_DIRECTORY) ) _advupload_error_die(619, $_POST);
              $validators = array(); // we had had validate all of thing upper
              $form_state_values = array(
                'title' => $node_title,
                'body' => '',
                $fieldname => array(
                  0 => array(
                    'fid' => 0,
                    'list' => '1',
                    'data' => array(
                      'description' => '',
                      'alt' => '',
                      'title' => '',
                    ),
                    'alt' => '',
                    'title' => '',
                    'filepath' => '',
                    'filename' => '',
                    'filemime' => '',
                    'filesize' => 0,
                    'filefield_upload' => 'Upload',
                    'filefield_remove' => 'Remove',
                    'upload' => 0,
                  ),
                  'node_status' => NULL,
                )
              );
              if($file = _advupload_field_file_save_file($tmpfpath, $directory, $fname) ) {
                error_log('File uploaded: ' . var_export($file, TRUE) );
                // no need to unlink temporary - it's moved
                db_query('DELETE FROM {files} WHERE fid=%d', $fid);
                $file['original_path'] = $tmpfpath;
                // now we must create node
                $node = _advupload_create_node($type, $field, $form_state_values, $file, $addfields = array() );
                error_log('$node->nid ' .$node->nid);
                die(
                  // drupal_to_js not enough ;-(
                  drupal_to_js(
                    array(
                      'jsonrpc' => '2.0', 'result' => 'success', 'id' => 'id',
                      'data' => array(
                         // if there will be need in nid ;-)
                         'nid' => $node->nid,
                         'newtokenvalue' =>  drupal_get_token($_POST['token_name'] . $node->nid)
                      ),
                    )
                  ) 
                );
              }else{
                @unlink($tmpfpath);
                db_query('DELETE FROM {files} WHERE fid=%d', $fid);
                _advupload_error_die(620, $_POST);
              }
            }else _advupload_error_die(609, $_POST);
          }else _advupload_error_die(608, $_POST);
        }else _advupload_error_die(607, $_POST);
      } _advupload_error_die(606, $_POST);
    }else _advupload_error_die(601);
  }
  // default way
  _advupload_error_die(603);
}
function advupload_json_node_list(){
  global $user;
  drupal_set_header('Content-type: text/plain; charset=utf-8');
  error_log('advupload_json_node_list()!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!');
  $nid = intval($_GET['nid'] );
  $token = empty($_GET['token'] ) ? '' : $_GET['token'];
  $token_value = empty($_GET['token_value'] )  ? '' : $_GET['token_value'];
  if($nid && (!empty($token) ) && (!empty($token_value) ) && drupal_valid_token($token_value, $token . $nid) ){
    die(
      drupal_to_js(
        array(
          'result' => array(
            'nid' => nid,
            'html' => theme('advupload_json_edit_node_draw', $nid),
          )
        ) 
      ) 
    );
  }
  drupal_set_header('HTTP/1.1 404 Not Found');
  die(drupal_to_js(array() ) );
}
